var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import { debounce } from 'throttle-debounce';
import { useTheme } from 'react-jss';
import { initiateFormFields, processField, updateFieldsRequirements, getValues, } from './helpers';
export var FieldsContext = React.createContext({});
// eslint-disable-next-line @typescript-eslint/no-empty-function
export var SetValueContext = React.createContext(function () { });
var Form = function (_a) {
    var fields = _a.fields, requiredFields = _a.required, allRequired = _a.allRequired, component = _a.component, onChange = _a.onChange, fieldGroup = _a.fieldGroup, runOnChangeInitially = _a.runOnChangeInitially, onEnterPress = _a.onEnterPress, _b = _a.className, className = _b === void 0 ? '' : _b, children = _a.children;
    var _c = React.useState(initiateFormFields(fields, requiredFields)), fieldsData = _c[0], setFieldsData = _c[1];
    var theme = useTheme();
    React.useEffect(function () {
        setFieldsData(function (prevState) { return updateFieldsRequirements(prevState, allRequired ? fields : requiredFields); });
    }, [requiredFields]);
    var debouncedOnChange = React.useCallback(debounce(500, function (nextValue, name) { return onChange && onChange(nextValue, name); }), []);
    var setValue = function (name, value, required, options) {
        if (onEnterPress && (options === null || options === void 0 ? void 0 : options.forceSubmit)) {
            onEnterPress(getValues(fieldsData));
        }
        if (!name) {
            // Not providing field name - a method to reset the whole form.
            setFieldsData(initiateFormFields(fields, allRequired ? fields : requiredFields));
        }
        else {
            setFieldsData(function (prevState) {
                var fieldsData = __assign(__assign({}, prevState), processField(name, value, required || false, options, theme.textLabels, theme.customValidationFunction));
                if (onChange) {
                    // If onChange prop is present, run it on every form change,
                    // except the initial load. When runOnChangeInitially prop is present,
                    // run it also on Initial load.
                    var formIsInitiated = Object.values(prevState)
                        .every(function (item) { return typeof item.value === 'undefined'; });
                    if (!formIsInitiated || runOnChangeInitially) {
                        debouncedOnChange(getValues(fieldsData), name);
                    }
                }
                return fieldsData;
            });
        }
    };
    // Prevent nesting <form> tags when using form as a Fieldgroup.
    var Component = fieldGroup ? 'div' : component || 'form';
    return (React.createElement(Component, { className: className || undefined },
        React.createElement(FieldsContext.Provider, { value: fieldsData },
            React.createElement(SetValueContext.Provider, { value: setValue }, children))));
};
export default Form;
