var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import DefaultButton from '../default/DefaultButton';
import useSubmit from './useSubmit';
import Loader from '../default/Loader';
/**
 * A button component to handle form actions, like submit or reset.
 */
var FormButton = function (_a) {
    var onClick = _a.onClick, component = _a.component, reset = _a.reset, loading = _a.loading, loadingComponent = _a.loadingComponent, suppressErrorMessage = _a.suppressErrorMessage, children = _a.children, otherProps = __rest(_a, ["onClick", "component", "reset", "loading", "loadingComponent", "suppressErrorMessage", "children"]);
    var Component = component || DefaultButton;
    var LoadingComponent = loadingComponent || Loader;
    var submit = useSubmit(suppressErrorMessage);
    return (React.createElement(Component, __assign({ onClick: function (e) { return submit && submit(e, onClick, reset); }, disabled: loading }, otherProps),
        loading && React.createElement(React.Fragment, null,
            React.createElement(LoadingComponent, null),
            "\u00A0"),
        children));
};
export default FormButton;
