/// <reference types="react" />
import { value, checkboxValue, fieldsData, textLabels, customValidationFunction, option } from '../typings';
/**
 * Process data from given field and prepare it for a form mutation.
 */
export declare function processField(name: string, value: value, required: boolean, options: {
    type?: string | undefined;
    min?: number | undefined;
    forceErrorMessage?: string | undefined;
} | undefined, textLabels: textLabels, customValidationFunction: customValidationFunction): {
    [x: string]: {
        value: any;
        validation: string;
        required: boolean;
        help: string;
    };
} | {
    [x: string]: {
        value: any;
        validation: string | null;
        required: boolean;
        help: string | true | null;
        type: string | undefined;
    };
};
/**
 * Generate initial form state, where all values are undefined.
 */
export declare function initiateFormFields(fieldNames: string[], required?: string[]): {};
/**
 * Reset valdiation states of all fields in a form.
 */
export declare function updateFieldsRequirements(fieldsData: fieldsData, required?: string[]): object;
/**
 * Parse option, which can be a string or an object, to return an object.
 */
export declare function parseOption(option: option): {
    optionLabel: import("react").ReactNode;
    optionValue: string;
};
/**
 * Update single checkbox value in a list of all checkboxes.
 */
export declare function checkboxHandler(checked: boolean, newValue: checkboxValue, previousValues: [checkboxValue]): checkboxValue[];
/**
 * Check whether whole form is filled correctly.
 */
export declare function formIsInvalid(fieldsData: fieldsData, fieldKeys?: never[]): boolean;
/**
 * Get values from all fields and organize them into API friendly format.
 */
export declare function getValues(fieldsData: fieldsData): object;
/**
 * Convert image url to image data format that is compatible with image upload
 * input.
 */
export declare function imageUrltoImageData(imageUrl: string): {
    name: string | undefined;
    data: string;
    type: string;
} | null;
