var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import theme from './theme';
export function inputHeight(height) {
    var _a;
    return {
        '& *.form-input': {
            height: height,
            lineHeight: "".concat(height - (height / 3), "px"),
            paddingTop: height / 6,
            paddingBottom: height / 6,
            '&[type=file]': {
                lineHeight: "".concat(height * 0.45, "px"),
            },
        },
        '& textarea.form-input': {
            minHeight: height,
            height: 'auto',
        },
        '& .form-select:not([multiple])': {
            backgroundPosition: "calc(100% - 15px) ".concat(height / 2 - 2, "px, calc(100% - 10px) ").concat(height / 2 - 2, "px"),
        },
        '& $prefix, & $suffix': {
            height: height,
            lineHeight: "".concat(height, "px"),
        },
        '&$inlineLabel > $label': (_a = {},
            _a[breakpoint(theme.breakpoints.sm)] = {
                lineHeight: "".concat(height, "px"),
                marginBottom: 0,
            },
            _a),
        '&$inlineLabel .form-checkitem': {
            marginTop: height / 4,
        },
    };
}
export function breakpoint(width) {
    return "@media (min-width: ".concat(width, ")");
}
export function clearfix() {
    return {
        '&:after': {
            content: '',
            display: 'table',
            clear: 'both',
        },
    };
}
export function overlay() {
    return {
        position: 'fixed',
        top: 0,
        right: 0,
        bottom: 0,
        left: 0,
        zIndex: 100,
    };
}
export function maxRows(amount) {
    return {
        overflow: 'hidden',
        display: '-webkit-box',
        '-webkit-line-clamp': amount || 1,
        '-webkit-box-orient': 'vertical',
    };
}
export function placeholder(styles) {
    return {
        '&::-moz-placeholder': __assign({}, styles),
        '&:-ms-input-placeholder': __assign({}, styles),
        '&::-webkit-input-placeholder': __assign({}, styles),
    };
}
