var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { FieldsContext, SetValueContext } from '../.';
var useControlLogic = function (InputComponent, _a) {
    var name = _a.name, label = _a.label, initialValue = _a.initialValue, type = _a.type, help = _a.help, className = _a.className, prefix = _a.prefix, suffix = _a.suffix, narrow = _a.narrow, large = _a.large, inlineLabel = _a.inlineLabel, inline = _a.inline, noBottomGutter = _a.noBottomGutter, disabled = _a.disabled, otherProps = __rest(_a, ["name", "label", "initialValue", "type", "help", "className", "prefix", "suffix", "narrow", "large", "inlineLabel", "inline", "noBottomGutter", "disabled"]);
    var fieldsData = React.useContext(FieldsContext);
    var setValue = React.useContext(SetValueContext);
    React.useEffect(function () {
        // Appply default field value on init and when it changes.
        if (initialValue) {
            setValue(name, initialValue, required);
        }
    }, [initialValue]);
    var fieldData = fieldsData[name] || {};
    var value = fieldData.value, validation = fieldData.validation, required = fieldData.required, fieldsDataHelp = fieldData.help;
    var inputProps = __assign(__assign({}, otherProps), { name: name, value: (value !== null ? value : initialValue) || '', required: required, type: type, setValue: setValue });
    var formControlProps = {
        name: name,
        inlineLabel: inlineLabel,
        inline: inline,
        narrow: narrow,
        large: large,
        noBottomGutter: noBottomGutter,
        validation: validation || '',
        disabled: disabled,
        displayName: InputComponent.displayName || '',
        label: label,
        help: fieldsDataHelp || help,
        prefix: prefix,
        suffix: suffix,
        className: className,
    };
    return {
        inputProps: inputProps,
        formControlProps: formControlProps,
    };
};
export default useControlLogic;
