import React from 'react';
import { useTheme } from 'react-jss';
import { FieldsContext, SetValueContext, getValues, formIsInvalid } from '..';
function useSubmit(suppressErrorMessage) {
    var theme = useTheme();
    var fieldsData = React.useContext(FieldsContext);
    var setValue = React.useContext(SetValueContext);
    var submit = function (e, callback, reset) {
        var _a;
        e.preventDefault();
        if (formIsInvalid(fieldsData)) {
            // Trigger valdiation check of all fields to prevent submitting before debounce etc.
            Object.entries(fieldsData).forEach(function (_a) {
                var key = _a[0], data = _a[1];
                var _b = data, value = _b.value, required = _b.required, type = _b.type;
                setValue(key, value, required, { type: type });
            });
            // TODO: Turn back the suppressErrorMessage prop support on TS.
            if (!suppressErrorMessage && (theme === null || theme === void 0 ? void 0 : theme.errorNotificationFunc) && ((_a = theme.textLabels) === null || _a === void 0 ? void 0 : _a.formInvalid)) {
                theme.errorNotificationFunc(theme.textLabels.formInvalid);
            }
        }
        else {
            callback && callback(getValues(fieldsData));
            reset && setValue();
        }
    };
    return submit;
}
export default useSubmit;
