import React from 'react';
import classNames from 'classnames';
import { parseOption, checkboxHandler, useCheckboxStyles, withFormControl, } from '../.';
var Checkboxes = function (_a) {
    var name = _a.name, value = _a.value, required = _a.required, setValue = _a.setValue, options = _a.options, small = _a.small;
    var classes = useCheckboxStyles();
    return (React.createElement("div", null, options.map(function (option, index) {
        var _a;
        var _b = parseOption(option), optionLabel = _b.optionLabel, optionValue = _b.optionValue;
        var checked = (value && value.includes(optionValue));
        return (React.createElement("label", { className: classNames(classes.label, 'form-checkitem', (_a = {}, _a[classes.small] = small, _a)), htmlFor: "".concat(name).concat(index), key: index },
            React.createElement("input", { type: 'checkbox', name: "".concat(name).concat(index), className: classes.input, id: "".concat(name).concat(index), checked: checked, onChange: function () {
                    var finalValue = checkboxHandler(!checked, optionValue, value);
                    setValue(name, finalValue, required);
                } }),
            " ",
            optionLabel));
    })));
};
export default withFormControl(Checkboxes);
