import React from 'react';
import { createUseStyles } from 'react-jss';
import { lighten } from 'polished';
var DefaultButton = function (_a) {
    var onClick = _a.onClick, disabled = _a.disabled, children = _a.children;
    var classes = useStyles();
    return (React.createElement("button", { type: 'button', className: classes.button, onClick: function (e) { return onClick(e); }, disabled: disabled }, children));
};
var useStyles = createUseStyles(function (theme) { return ({
    button: {
        padding: "0 ".concat(theme.sizes.inputHeight / 2, "px"),
        fontSize: theme.typography.inputFontSize,
        lineHeight: "".concat(theme.sizes.inputHeight, "px"),
        height: theme.sizes.inputHeight,
        borderWidth: 0,
        borderRadius: theme.sizes.borderRadius,
        whiteSpace: 'nowrap',
        color: 'white',
        backgroundColor: theme.colors.accent,
        cursor: 'pointer',
        display: 'inline-flex',
        justifyContent: 'center',
        '&:hover': {
            backgroundColor: lighten(0.1, theme.colors.accent),
        },
        '&:focus': {
            outline: 'none',
        },
        '&:disabled': {
            opacity: 0.6,
            pointerEvents: 'none',
        },
    },
}); });
export default DefaultButton;
