var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import classNames from 'classnames';
import { lighten } from 'polished';
import { createUseStyles } from 'react-jss';
import { breakpoint, inputHeight, placeholder, } from '../.';
var FormControl = function (_a) {
    var _b;
    var name = _a.name, inlineLabel = _a.inlineLabel, inline = _a.inline, narrow = _a.narrow, large = _a.large, noBottomGutter = _a.noBottomGutter, validation = _a.validation, disabled = _a.disabled, displayName = _a.displayName, label = _a.label, help = _a.help, prefix = _a.prefix, suffix = _a.suffix, _c = _a.className, className = _c === void 0 ? '' : _c, children = _a.children;
    var classes = useStyles();
    return (React.createElement("div", { className: classNames(classes.formControl, 'form-control', (_b = {},
            _b[classes.inlineLabel] = inlineLabel,
            _b[classes.inline] = inline,
            _b[classes.narrow] = narrow,
            _b[classes.large] = large,
            _b[classes.noBottomGutter] = noBottomGutter,
            _b[classes.withPrefix] = prefix,
            _b[classes.withSuffix] = suffix,
            _b[classes[validation || '']] = validation,
            _b[classes.disabled] = disabled,
            _b[className] = className,
            _b)) },
        label
            ? displayName && ['Checkbox', 'Checkboxes', 'Radio', 'Switch'].find(function (item) { return displayName.includes(item); })
                ? React.createElement("span", { className: classes.label }, label)
                : React.createElement("label", { className: classes.label, htmlFor: name }, label)
            : null,
        children,
        prefix && React.createElement("div", { className: classes.prefix }, prefix),
        suffix && React.createElement("div", { className: classes.suffix }, suffix),
        help && React.createElement("span", { className: classes.help }, help)));
};
var useStyles = createUseStyles(function (theme) {
    var _a, _b, _c, _d, _e, _f;
    return ({
        formControl: __assign(__assign({ margin: 0, marginBottom: theme.sizes.inputGutterBottom, position: 'relative', width: theme.sizes.inputWidth, overflow: 'visible', boxSizing: 'border-box', maxWidth: '100%', textAlign: 'left' }, inputHeight(theme.sizes.inputHeight)), { '& .form-input': __assign(__assign(__assign({ width: '100%', margin: 0, borderStyle: 'solid', borderColor: theme.colors.inputBorder, borderRadius: theme.sizes.borderRadius, borderWidth: theme.sizes.onlyBottomBorder ? 0 : theme.sizes.borderWidth }, theme.sizes.onlyBottomBorder
                ? { borderBottomWidth: theme.sizes.borderWidth }
                : {}), { boxSizing: 'border-box', fontSize: theme.typography.inputFontSize, fontWeight: theme.typography.inputFontWeight, transition: 'all 200ms ease-in', backgroundColor: theme.colors.inputBg, paddingLeft: theme.sizes.inputSidePaddings, paddingRight: theme.sizes.inputSidePaddings, color: theme.colors.inputText, '-webkit-appearance': 'none' }), placeholder({
                color: theme.colors.placeholder,
            })), '& .form-input[type=number]': {
                '-moz-appearance': 'textfield',
                appearance: 'textfield',
                '&::-webkit-inner-spin-button': {
                    '-webkit-appearance': 'none',
                },
            }, '& textarea ~ $addon': {
                top: 0,
                bottom: 'auto',
            }, '& $label ~ textarea ~ $addon': {
                top: Math.floor(theme.typography.labelFontSize * 1.4 + theme.sizes.labelGutterBottom),
            }, 
            // States
            '& .form-input:focus': {
                borderColor: theme.colors.accent,
                boxShadow: theme.colors.inputFocusShadow,
                outlineWidth: 0,
                outline: 'none',
            } }),
        disabled: {
            opacity: 0.5,
            cursor: 'not-allowed',
            '& .form-input, & .form-checkitem': {
                pointerEvents: 'none',
            },
        },
        success: {
            '& $label, & $addon, & $help': {
                color: theme.colors.success,
            },
            '& .form-input:not(:focus)': {
                borderColor: theme.colors.success,
            },
        },
        withPrefix: {
            '& .form-input': {
                paddingLeft: theme.sizes.inputSidePaddings + theme.sizes.prefixExtraSpacing,
            },
        },
        withSuffix: {
            '& .form-input': {
                paddingRight: theme.sizes.inputSidePaddings + theme.sizes.prefixExtraSpacing,
            },
        },
        error: {
            '& $label, & $addon, & $help, & .form-checkitem': {
                color: theme.colors.error,
            },
            '& .form-input:not(:focus)': {
                borderColor: theme.colors.error,
                backgroundColor: lighten(0.54, theme.colors.error),
            },
        },
        label: {
            display: 'block',
            margin: 0,
            marginBottom: theme.sizes.labelGutterBottom,
            fontSize: theme.typography.labelFontSize,
            lineHeight: 'normal',
            textTransform: 'none',
            textAlign: 'left',
            fontWeight: theme.typography.labelFontWeight,
            color: theme.colors.label,
        },
        help: {
            position: 'absolute',
            top: '100%',
            display: 'block',
            margin: 0,
            fontSize: theme.typography.helpFontSize,
            lineHeight: 'normal',
            color: theme.colors.inputText,
        },
        prefix: {
            position: 'absolute',
            bottom: 0,
            left: theme.sizes.inputSidePaddings,
        },
        suffix: {
            position: 'absolute',
            bottom: 0,
            right: theme.sizes.inputSidePaddings,
        },
        // Modifiers
        large: __assign(__assign({}, inputHeight(theme.sizes.inputHeight + theme.sizes.largeInputExtraHeight)), { '& $label': {
                marginBottom: 2,
            } }),
        inlineLabel: (_a = {},
            _a[breakpoint(theme.breakpoints.sm)] = {
                display: 'flex',
                width: '100%',
            },
            _a['& $label'] = (_b = {},
                _b[breakpoint(theme.breakpoints.sm)] = {
                    marginBottom: 0,
                    marginRight: 10,
                    minWidth: theme.sizes.inlineLabelWidth,
                    maxWidth: theme.sizes.inlineLabelWidth,
                    whiteSpace: 'nowrap',
                },
                _b['& + *'] = (_c = {},
                    _c[breakpoint(theme.breakpoints.sm)] = {
                        flexGrow: 1,
                    },
                    _c),
                _b),
            _a['& $help'] = (_d = {},
                _d[breakpoint(theme.breakpoints.sm)] = {
                    left: theme.sizes.inlineLabelWidth + 10,
                },
                _d),
            _a['& $label ~ textarea ~ $addon'] = (_e = {},
                _e[breakpoint(theme.breakpoints.sm)] = {
                    top: 0,
                },
                _e),
            _a),
        inline: {
            width: '100%',
            '& .form-checkitem': {
                display: 'inline-flex',
                whiteSpace: 'nowrap',
                marginRight: 20,
                '&:last-of-type': {
                    marginLeft: 0,
                },
            },
        },
        narrow: (_f = {},
            _f[breakpoint(theme.breakpoints.sm)] = {
                maxWidth: theme.sizes.narrowInputWidth,
            },
            _f),
        noBottomGutter: {
            marginBottom: 0,
        },
    });
});
export default FormControl;
