import React from 'react';
import { createUseStyles } from 'react-jss';
import classNames from 'classnames';
import { lighten } from 'polished';
import { withFormControl, checkboxHandler } from '../.';
var ImageSelect = function (_a) {
    var name = _a.name, value = _a.value, required = _a.required, setValue = _a.setValue, options = _a.options, multiple = _a.multiple;
    var classes = useStyles();
    return (React.createElement("div", { className: classes.ImageSelect }, options.map(function (option, index) {
        var _a;
        var checked = (value && multiple ? value.includes(option.value) : value === option.value);
        return (React.createElement("div", { key: index, className: classNames(classes.input, 'form-checkitem', (_a = {}, _a[classes.isChecked] = checked, _a)), onClick: function () {
                var finalValue = multiple ? checkboxHandler(!checked, option.value, value) : option.value;
                setValue(name, finalValue, required);
            } },
            React.createElement("img", { src: option.image, alt: '' }),
            option.label && React.createElement("span", { className: classes.label }, option.label)));
    })));
};
var useStyles = createUseStyles(function (theme) { return ({
    ImageSelect: {
        display: 'flex',
        alignItems: 'center',
    },
    input: {
        flex: '65px 0 0',
        display: 'flex',
        flexDirection: 'column',
        alignItems: 'center',
        justifyContent: 'space-between',
        fontSize: 9,
        lineHeight: 'normal',
        marginTop: 5,
        marginBottom: 10,
        padding: '0 1px',
        color: theme.colors.inputText,
        cursor: 'pointer',
        position: 'relative',
        zIndex: 1,
    },
    label: {
        marginTop: 12,
    },
    isChecked: {
        '&:before': {
            content: '""',
            position: 'absolute',
            top: -5,
            right: 1,
            bottom: -5,
            left: 1,
            backgroundColor: lighten(0.6, theme.colors.accent),
            border: "1px solid ".concat(theme.colors.accent),
            borderRadius: theme.sizes.borderRadius,
            zIndex: -1,
        },
    },
}); });
export default withFormControl(ImageSelect);
