var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import { createUseStyles } from 'react-jss';
import { lighten, darken } from 'polished';
import { withFormControl, maxRows } from '../.';
var ImageUpload = function (_a) {
    var name = _a.name, value = _a.value, placeholder = _a.placeholder, required = _a.required, setValue = _a.setValue;
    var classes = useStyles();
    return (!value
        ? React.createElement("div", { className: classes.root },
            React.createElement("input", { accept: 'image/*', className: classes.input, id: name, type: 'file', onChange: function (e) {
                    var fileReader = new FileReader();
                    var files = e.target.files;
                    var _a = files[0], fileName = _a.name, fileType = _a.type;
                    var dataFile = files[0];
                    fileReader.readAsDataURL(files[0]);
                    fileReader.onload = function () {
                        var data = fileReader.result;
                        setValue(name, {
                            name: fileName,
                            type: fileType.split('/')[0],
                            data: data,
                            dataFile: dataFile,
                        }, required);
                    };
                } }),
            React.createElement("label", { htmlFor: name },
                React.createElement("div", { className: classes.upload },
                    "+ Upload ",
                    placeholder || 'image')))
        : React.createElement("div", { className: classes.root },
            React.createElement("img", { src: typeof value === 'string' && value.includes('http')
                    ? value
                    : value.data, className: classes.image, alt: 'Uploaded file' }),
            React.createElement("div", { className: classes.filename }, typeof value === 'string'
                ? value
                : value.name || value.data.split('/').pop()),
            React.createElement("button", { className: classes.delete, onClick: function () { return setValue(name, '', required); } },
                "Delete ",
                placeholder || 'image')));
};
var useStyles = createUseStyles(function (theme) { return ({
    root: {
        textAlign: 'center',
        padding: 20,
        backgroundColor: theme.colors.fill,
        maxWidth: 300,
        borderRadius: theme.sizes.borderRadius,
    },
    input: {
        display: 'none',
    },
    upload: {
        border: "2px dashed ".concat(darken(0.2, theme.colors.inputBorder)),
        color: darken(0.3, theme.colors.inputBorder),
        padding: '30px 20px',
        cursor: 'pointer',
        fontSize: theme.typography.labelFontSize,
        lineHeight: 'normal',
        '&:hover': {
            backgroundColor: lighten(0.02, theme.colors.fill),
        },
    },
    delete: {
        backgroundColor: theme.colors.accent,
        color: theme.colors.inputBg !== 'transparent' ? theme.colors.inputBg : 'white',
        fontSize: theme.typography.labelFontSize,
        lineHeight: 'normal',
        padding: '5px 8px',
        border: 'none',
        cursor: 'pointer',
        '&:hover': {
            backgroundColor: lighten(0.02, theme.colors.accent),
        },
    },
    image: {
        display: 'block',
        backgroundColor: 'white',
        padding: 5,
        margin: '0 auto 10px',
        maxWidth: '100%',
        boxSizing: 'border-box',
    },
    filename: __assign({ maxWidth: '100%', textOverflow: 'ellipsis', marginBottom: 10, fontSize: 11, color: theme.colors.inputText, lineHeight: 'normal', textAlign: 'center' }, maxRows()),
}); });
export default withFormControl(ImageUpload);
