var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { debounce } from 'throttle-debounce';
import { withFormControl } from '../.';
var Input = function (_a) {
    var name = _a.name, _b = _a.type, type = _b === void 0 ? 'text' : _b, value = _a.value, placeholder = _a.placeholder, min = _a.min, _c = _a.debounceTime, debounceTime = _c === void 0 ? 500 : _c, accept = _a.accept, activateEnterPress = _a.activateEnterPress, required = _a.required, setValue = _a.setValue, otherProps = __rest(_a, ["name", "type", "value", "placeholder", "min", "debounceTime", "accept", "activateEnterPress", "required", "setValue"]);
    var _d = React.useState(''), internalValue = _d[0], setInternalValue = _d[1];
    // Apply initial value and react on initialValue change.
    React.useEffect(function () {
        setInternalValue(value);
    }, [value]);
    var handleSetValue = function (val) {
        setValue(name, val, required, { type: type, min: min });
    };
    var debouncedSetValue = React.useCallback(debounce(debounceTime, function (nextValue) { return handleSetValue(nextValue); }), []);
    return (React.createElement("input", __assign({ className: 'form-input', name: name, type: type === 'password-novalidation' ? 'password' : type, 
        // This allows to add a custom validation rule for password field, while still
        // being able to skip the check where it is not neccessary, eg. on login forms.
        placeholder: placeholder, onChange: function (e) {
            var _a;
            if (type === 'file' && ((_a = e.target.files) === null || _a === void 0 ? void 0 : _a.length)) {
                var fileReader_1 = new FileReader();
                var dataFile_1 = e.target.files[0];
                var fileName_1 = dataFile_1.name, fileType_1 = dataFile_1.type;
                fileReader_1.readAsDataURL(e.target.files[0]);
                fileReader_1.onload = function () {
                    var data = fileReader_1.result;
                    setValue(name, {
                        name: fileName_1,
                        type: fileType_1.split('/')[0],
                        data: data,
                        dataFile: dataFile_1,
                    }, required);
                };
            }
            else {
                setInternalValue(e.target.value);
                debouncedSetValue(e.target.value);
            }
        }, onKeyPress: function (e) {
            if (activateEnterPress && e.code === 'Enter') {
                e.preventDefault();
                setValue(name, internalValue, required, { type: type, min: min, forceSubmit: true });
            }
        }, accept: accept, value: type !== 'file' ? internalValue : undefined, onBlur: function (e) { return handleSetValue(e.target.value); } }, otherProps)));
};
export default withFormControl(Input);
