var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React from 'react';
import { createUseStyles } from 'react-jss';
import classNames from 'classnames';
import { lighten } from 'polished';
import { withFormControl, breakpoint } from '../.';
var MultiImageUpload = function (_a) {
    var name = _a.name, value = _a.value, required = _a.required, setValue = _a.setValue, _b = _a.columns, columns = _b === void 0 ? 4 : _b;
    var classes = useStyles({ columns: columns });
    return (React.createElement("div", { className: classes.root },
        value &&
            value.map(function (item, index) {
                return React.createElement("div", { className: classes.item, key: index },
                    React.createElement("div", { className: classes.imageWrapper },
                        React.createElement("img", { src: typeof item === 'object' ? item.data : item, className: classes.image, alt: "Uploaded file ".concat(index) }),
                        React.createElement("div", { className: classes.delete, onClick: function () { return setValue(name, value.filter(function (_subItem, subIndex) { return subIndex !== index; }), required); } }, "\u2A2F")));
            }),
        React.createElement("div", { className: classes.item },
            React.createElement("input", { accept: 'image/*', className: classes.input, id: name, multiple: true, type: 'file', onChange: function (e) {
                    var oldValue = value || [];
                    var files = e.target.files;
                    Object.values(files).forEach(function (value) {
                        var fileReader = new FileReader();
                        var fileName = value.name, fileType = value.type;
                        var dataFile = value;
                        fileReader.readAsDataURL(value);
                        fileReader.onload = function () {
                            var data = fileReader.result;
                            setValue(name, __spreadArray(__spreadArray([], oldValue, true), [{
                                    fileName: fileName,
                                    type: fileType.split('/')[0],
                                    data: data,
                                    dataFile: dataFile,
                                }], false), required);
                            oldValue = __spreadArray(__spreadArray([], oldValue, true), [{
                                    fileName: fileName,
                                    type: fileType.split('/')[0],
                                    data: data,
                                    dataFile: dataFile,
                                }], false);
                        };
                    });
                } }),
            React.createElement("label", { htmlFor: name, className: classNames(classes.imageWrapper, classes.label) }, "Add more"))));
};
var useStyles = createUseStyles(function (theme) {
    var _a, _b;
    return ({
        root: {
            display: 'flex',
            flexWrap: 'wrap',
            margin: -10,
        },
        item: (_a = {
                maxWidth: '50%',
                minWidth: '50%',
                padding: 10,
                boxSizing: 'border-box'
            },
            _a[breakpoint(theme.breakpoints.md)] = {
                maxWidth: function (_a) {
                    var columns = _a.columns;
                    return "".concat(100 / columns, "%");
                },
                minWidth: function (_a) {
                    var columns = _a.columns;
                    return "".concat(100 / columns, "%");
                },
            },
            _a),
        imageWrapper: (_b = {
                display: 'flex',
                alignItems: 'center',
                justifyContent: 'center',
                backgroundColor: theme.colors.fill,
                padding: 15,
                height: '33vw',
                position: 'relative'
            },
            _b[breakpoint(theme.breakpoints.md)] = {
                height: '20vw',
            },
            _b[breakpoint(theme.breakpoints.lg)] = {
                height: '12vw',
                maxHeight: 300,
            },
            _b),
        image: {
            maxWidth: '100%',
            maxHeight: '100%',
        },
        delete: {
            position: 'absolute',
            top: '-0.5em',
            right: 0,
            lineHeight: '30px',
            fontSize: 30,
            padding: 5,
            cursor: 'pointer',
            '&:hover': {
                color: theme.colors.inputBorder,
            },
        },
        input: {
            display: 'none',
        },
        label: {
            display: 'flex',
            flexDrection: 'column',
            cursor: 'pointer',
            alignItems: 'center',
            justifyContent: 'center',
            color: theme.colors.inputText,
            '&:hover': {
                backgroundColor: lighten(0.04, theme.colors.fill),
            },
        },
    });
});
export default withFormControl(MultiImageUpload);
