var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import { createUseStyles } from 'react-jss';
import classNames from 'classnames';
import { withFormControl, parseOption, checkboxHandler, overlay, useSelectStyles, } from '../.';
var MultiSelect = function (_a) {
    var name = _a.name, value = _a.value, placeholder = _a.placeholder, required = _a.required, setValue = _a.setValue, options = _a.options;
    var _b = React.useState(false), isOpen = _b[0], setIsOpen = _b[1];
    var selectClasses = useSelectStyles();
    var multiSelectClasses = useStyles();
    var classes = __assign(__assign({}, selectClasses), multiSelectClasses);
    return (React.createElement("div", { className: classNames(classes.select, classes.multiSelect, 'form-input form-select'), onClick: function () { return !isOpen && setIsOpen(true); } },
        value && value.length && options && options.length
            ? React.createElement("div", { className: classes.values }, value.map(function (option, index) {
                var optionLabel = parseOption(option).optionLabel;
                return React.createElement("span", { key: index, className: classes.value }, optionLabel);
            }))
            : placeholder || (required ? 'Select' : 'All'),
        isOpen &&
            React.createElement(React.Fragment, null,
                React.createElement("div", { className: classes.overlay, onClick: function () { return setIsOpen(false); } }),
                React.createElement("div", { className: classes.options }, options.map(function (option, index) {
                    var _a;
                    var _b = parseOption(option), optionLabel = _b.optionLabel, optionValue = _b.optionValue;
                    var checked = (value && value.includes(optionValue));
                    return React.createElement("div", { key: index, className: classNames(classes.option, (_a = {}, _a[classes.isChecked] = checked, _a)), onClick: function () { return setValue(name, checkboxHandler(!checked, optionValue, value), required); } },
                        optionLabel,
                        checked &&
                            React.createElement(React.Fragment, null,
                                React.createElement("span", { className: classes.check }, "\u2713"),
                                React.createElement("span", { className: classes.close }, "\u2717")));
                })))));
};
export var useStyles = createUseStyles(function (theme) { return ({
    multiSelect: {
        position: 'relative',
        height: 'auto !important',
    },
    values: {
        margin: -3,
    },
    value: {
        padding: '0 5px',
        backgroundColor: theme.colors.fill,
        borderRadius: 3,
        whiteSpace: 'nowrap',
        display: 'inline-block',
        margin: 3,
    },
    options: {
        position: 'absolute',
        top: '100%',
        left: -1,
        right: -2,
        height: theme.sizes.inputHeight * 5,
        border: "1px solid ".concat(theme.colors.inputBorder),
        backgroundColor: 'white',
        zIndex: 101,
        overflowY: 'scroll',
    },
    option: {
        padding: '3px 5px',
        marginBottom: 1,
        cursor: 'pointer',
        display: 'flex',
        justifyContent: 'space-between',
        '&:hover': {
            backgroundColor: 'rgba(0,0,0,0.04)',
        },
    },
    isChecked: {
        backgroundColor: 'rgba(0,0,0,0.12)',
        '&:hover ': {
            backgroundColor: 'rgba(0,0,0,0.08)',
            '& $check': {
                display: 'none',
            },
            '& $close': {
                display: 'inline',
            },
        },
    },
    check: {
        color: 'rgba(0,0,0,0.12)',
    },
    close: {
        display: 'none',
        color: 'rgba(0,0,0,0.2)',
    },
    overlay: __assign({}, overlay()),
}); });
export default withFormControl(MultiSelect);
