import React from 'react';
import classNames from 'classnames';
import { createUseStyles } from 'react-jss';
import { parseOption, withFormControl } from '../.';
var Radio = function (_a) {
    var name = _a.name, value = _a.value, required = _a.required, small = _a.small, setValue = _a.setValue, options = _a.options;
    var classes = useStyles();
    return (React.createElement("div", null, options.map(function (option, index) {
        var _a;
        var _b = parseOption(option), optionLabel = _b.optionLabel, optionValue = _b.optionValue;
        return (React.createElement("label", { className: classNames(classes.label, 'form-checkitem', (_a = {}, _a[classes.small] = small, _a)), key: index, htmlFor: "".concat(name).concat(index) },
            React.createElement("input", { type: 'radio', name: name, value: optionValue, className: classes.input, id: "".concat(name).concat(index), checked: optionValue === value, onChange: function (e) { return setValue(name, e.target.value, required); } }),
            " ",
            optionLabel));
    })));
};
var useStyles = createUseStyles({
    label: {
        display: 'flex',
        cursor: 'pointer',
    },
    input: {
        marginRight: 10,
        transform: 'translateY(0.3em)',
    },
    small: {
        fontSize: 12,
        lineHeight: '18px',
        '& $input': {
            marginRight: 5,
        },
    },
});
export default withFormControl(Radio);
