import React from 'react';
import { createUseStyles } from 'react-jss';
import classNames from 'classnames';
import { breakpoint } from '..';
var Row = function (_a) {
    var _b;
    var mobile = _a.mobile, noBottomGutter = _a.noBottomGutter, _c = _a.className, className = _c === void 0 ? '' : _c, children = _a.children;
    var classes = useStyles();
    return (React.createElement("div", { className: classNames((_b = {},
            _b[classes.row] = !mobile,
            _b[classes.rowMobile] = mobile,
            _b[classes.noBottomGutter] = noBottomGutter,
            _b[className] = className,
            _b)) }, children));
};
var useStyles = createUseStyles(function (theme) {
    var _a;
    var commonStyling = {
        display: 'flex',
        alignItems: 'flex-end',
        marginBottom: theme.sizes.inputGutterBottom,
        '& .form-control': {
            marginBottom: 0,
        },
        '& > div + *': {
            marginLeft: theme.sizes.rowGutter,
        },
    };
    return {
        row: (_a = {},
            _a[breakpoint(theme.breakpoints.sm)] = commonStyling,
            _a),
        rowMobile: commonStyling,
        noBottomGutter: {
            marginBottom: 0,
        },
    };
});
export default Row;
