import React from 'react';
import { createUseStyles } from 'react-jss';
import classNames from 'classnames';
import { withFormControl, parseOption } from '../.';
var Select = function (_a) {
    var name = _a.name, value = _a.value, placeholder = _a.placeholder, required = _a.required, setValue = _a.setValue, options = _a.options;
    var classes = useSelectStyles();
    return (React.createElement("select", { className: classNames(classes.select, 'form-input form-select'), name: name, value: value, onChange: function (e) { return setValue(name, e.target.value, required); } },
        (!value || !required) && React.createElement("option", { value: '', disabled: required }, placeholder || (required ? 'Select' : 'All')),
        options.map(function (option, index) {
            var _a = parseOption(option), optionLabel = _a.optionLabel, optionValue = _a.optionValue;
            return (React.createElement("option", { key: index, value: optionValue }, optionLabel));
        })));
};
export var useSelectStyles = createUseStyles(function (theme) { return ({
    select: {
        paddingRight: "35px !important",
        cursor: 'pointer',
        // Remove default caret
        '-webkit-appearance': 'none',
        '&::-ms-expand': {
            display: 'none',
        },
        // Custom caret
        '&:not([multiple])': {
            backgroundImage: "linear-gradient(45deg,transparent 50%,".concat(theme.colors.inputText, " 0),linear-gradient(135deg,").concat(theme.colors.inputText, " 50%,transparent 0)"),
            backgroundSize: '5px 5px, 5px 5px',
            backgroundRepeat: 'no-repeat',
        },
        '&[multiple]': {
            height: 'auto',
        },
        '&:-webkit-autofill': {
            backgroundColor: "".concat(theme.colors.inputBg, " !important"),
            transition: 'background-color 5000s ease-in-out 0s',
        },
    },
}); });
export default withFormControl(Select);
