import React from 'react';
import { createUseStyles } from 'react-jss';
import { withFormControl } from '../.';
var Slider = function (_a) {
    var name = _a.name, value = _a.value, required = _a.required, setValue = _a.setValue, _b = _a.min, min = _b === void 0 ? 0 : _b, _c = _a.max, max = _c === void 0 ? 300 : _c, _d = _a.step, step = _d === void 0 ? 1 : _d, unit = _a.unit;
    var classes = useStyles();
    return (React.createElement("div", null,
        React.createElement("input", { className: classes.input, type: 'range', name: name, value: value || 0, min: min, max: max, onChange: function (e) {
                var newVal = parseInt(e.target.value);
                setValue(name, Math.floor(newVal / step) * step, required);
            } }),
        React.createElement("div", { className: classes.value },
            value || '0',
            unit && " ".concat(unit))));
};
var useStyles = createUseStyles(function (theme) { return ({
    input: {
        padding: 0,
        '-webkit-appearance': 'none',
        display: 'flex',
        width: '100%',
        cursor: 'pointer',
        height: theme.sizes.inputHeight,
        marginBottom: -5,
        backgroundColor: 'transparent',
        '&:focus': {
            outline: 'none',
        },
        '&::-webkit-slider-runnable-track': {
            backgroundColor: theme.colors.inputBorder,
            boxShadow: '0 0 60px 15px white',
            height: 6,
        },
        '&::-webkit-slider-thumb': {
            width: 12,
            height: 12,
            borderRadius: 6,
            marginTop: -3,
            backgroundColor: theme.colors.accent,
            border: 'none',
            '-webkit-appearance': 'none',
        },
    },
    value: {
        color: theme.colors.inputText,
        fontSize: 13,
        textAlign: 'right',
        whiteSpace: 'nowrap',
        position: 'absolute',
        top: -3,
        right: 0,
    },
}); });
export default withFormControl(Slider);
