import React from 'react';
import { createUseStyles } from 'react-jss';
import classNames from 'classnames';
import { darken } from 'polished';
import { withFormControl } from '../.';
var Switch = function (_a) {
    var name = _a.name, value = _a.value, text = _a.text, required = _a.required, setValue = _a.setValue;
    var classes = useSwitchStyles();
    return (React.createElement("label", { className: classNames(classes.label, 'form-checkitem'), htmlFor: name },
        React.createElement("input", { type: 'checkbox', name: name, className: classes.input, id: name, checked: value, onChange: function (e) { return setValue(name, e.target.checked, required); } }),
        " ",
        text));
};
export var useSwitchStyles = createUseStyles(function (theme) { return ({
    label: {
        display: 'flex',
        position: 'relative',
        textAlign: 'left',
        alignItems: 'flex-start',
        cursor: 'pointer',
    },
    input: {
        position: 'relative',
        minWidth: theme.sizes.inputHeight * 7 / 8,
        height: theme.sizes.inputHeight / 2,
        display: 'inline-block',
        backgroundColor: theme.colors.inputBg,
        marginRight: 10,
        padding: 0,
        borderRadius: theme.sizes.inputHeight / 4,
        '-webkit-appearance': 'none',
        border: "1px solid ".concat(darken(0.2, theme.colors.inputBorder)),
        outline: 0,
        verticalAlign: 'middle',
        transform: 'translateY(0.3em)',
        cursor: 'pointer',
        transition: 'background-color 100ms ease-in',
        '&::after': {
            content: '""',
            display: 'block',
            width: theme.sizes.inputHeight / 2 + 2,
            height: theme.sizes.inputHeight / 2 + 2,
            position: 'absolute',
            left: -1,
            top: -2,
            backgroundColor: theme.colors.inputBorder,
            border: "1px solid ".concat(darken(0.2, theme.colors.inputBorder)),
            borderRadius: '50%',
            boxSizing: 'border-box',
            transition: 'left 200ms ease-in',
        },
        '&:checked': {
            backgroundColor: theme.colors.success,
            '&::after': {
                left: 'calc(100% - 19px)',
            },
        },
    },
}); });
export default withFormControl(Switch);
