import React from 'react';
import classNames from 'classnames';
import { withFormControl, checkboxHandler, useSwitchStyles } from '../.';
var Switches = function (_a) {
    var name = _a.name, value = _a.value, required = _a.required, setValue = _a.setValue, options = _a.options;
    var classes = useSwitchStyles();
    return (React.createElement("div", null, options.map(function (option, index) {
        var optionLabel = (typeof option === 'string') ? option : option.label;
        var optionValue = (typeof option === 'string') ? option : option.value;
        var checked = (value && value.includes(optionValue));
        return (React.createElement("label", { className: classNames(classes.label, 'form-checkitem'), htmlFor: "".concat(name).concat(index), key: index },
            React.createElement("input", { type: 'checkbox', name: "".concat(name).concat(index), className: classes.input, id: "".concat(name).concat(index), checked: checked, onChange: function () {
                    var finalValue = checkboxHandler(!checked, optionValue, value);
                    setValue(name, finalValue, required);
                } }),
            " ",
            optionLabel));
    })));
};
export default withFormControl(Switches);
