import React from 'react';
export declare type value = any;
export declare type setValue = (name?: string, value?: value, required?: boolean | undefined, options?: anyObject) => void;
export declare type checkboxValue = boolean | string;
export declare type option = string | {
    label: React.ReactNode;
    value: string;
};
export declare type options = option[];
export declare type validation = 'error' | 'success' | null;
export declare type anyObject = {
    [key: string]: any;
};
export declare type fieldData = {
    value: value;
    required: boolean;
    help: string;
    validation: validation;
    type?: string;
};
export declare type fieldsData = {} | {
    [key: string]: fieldData;
};
export declare type textLabels = {
    formInvalid: string;
    requiredField: string;
    minChars: string;
    passwordInvalid: string;
    emailInvalid: string;
    urlInvalid: string;
    phoneInvalid: string;
    postCodeInvalid: string;
    jsonInvalid: string;
};
export declare type errorNotificationFunc = (message: string) => void;
export declare type customValidationFunction = (value: value, type: string) => boolean;
export interface fullTheme {
    sizes: {
        inputHeight: number;
        inputWidth: number | string;
        inputGutterBottom: number;
        inputSidePaddings: number;
        labelGutterBottom: number;
        narrowInputWidth: number;
        inlineLabelWidth: number;
        borderRadius: number;
        borderWidth: number;
        rowGutter: number;
        formActionsDistance: number;
        onlyBottomBorder: boolean;
        largeInputExtraHeight: number;
        prefixExtraSpacing: number;
    };
    colors: {
        accent: string;
        inputText: string;
        inputBorder: string;
        inputBg: string;
        inputFocusShadow: string;
        label: string;
        fill: string;
        placeholder: string;
        success: string;
        error: string;
    };
    typography: {
        inputFontSize: number;
        inputFontWeight: string;
        labelFontSize: number;
        labelFontWeight: string;
        helpFontSize: number;
    };
    breakpoints: {
        xs: number | string;
        sm: string;
        md: string;
        lg: string;
    };
    textLabels: textLabels;
    toastContainerProps: object;
    errorNotificationFunc: errorNotificationFunc;
    customValidationFunction: customValidationFunction;
}
export interface themeOverrides {
    sizes?: {
        inputHeight?: number;
        inputWidth?: number | string;
        inputGutterBottom?: number;
        inputSidePaddings?: number;
        labelGutterBottom?: number;
        narrowInputWidth?: number;
        inlineLabelWidth?: number;
        borderRadius?: number;
        borderWidth?: number;
        rowGutter?: number;
        formActionsDistance?: number;
        onlyBottomBorder?: boolean;
        largeInputExtraHeight?: number;
        prefixExtraSpacing?: number;
    };
    colors?: {
        accent?: string;
        inputText?: string;
        inputBorder?: string;
        inputBg?: string;
        inputFocusShadow?: string;
        label?: string;
        fill?: string;
        placeholder?: string;
        success?: string;
        error?: string;
    };
    typography?: {
        inputFontSize?: number;
        inputFontWeight?: string;
        labelFontSize?: number;
        labelFontWeight?: string;
        helpFontSize?: number;
    };
    breakpoints?: {
        xs?: number | string;
        sm?: string;
        md?: string;
        lg?: string;
    };
    textLabels?: {
        formInvalid?: string;
        requiredField?: string;
        minChars?: string;
        passwordInvalid?: string;
        emailInvalid?: string;
        urlInvalid?: string;
        phoneInvalid?: string;
        postCodeInvalid?: string;
        jsonInvalid?: string;
    };
    toastContainerProps?: object;
    errorNotificationFunc?: errorNotificationFunc;
    customValidationFunction?: customValidationFunction;
}
export interface ControlLogicProps {
    addon?: React.ReactNode;
    children?: React.ReactNode;
    className?: string;
    disabled?: boolean;
    help?: React.ReactNode;
    initialValue?: any;
    inline?: boolean;
    inlineLabel?: boolean;
    label?: React.ReactNode;
    large?: boolean;
    name: string;
    narrow?: boolean;
    noBottomGutter?: boolean;
    required?: boolean;
    type?: string;
    validation?: validation;
    [key: string]: any;
}
export interface FormControlProps {
    name: string;
    inlineLabel?: boolean;
    inline?: boolean;
    narrow?: boolean;
    large?: boolean;
    noBottomGutter?: boolean;
    validation: validation;
    disabled?: boolean;
    displayName: string;
    label?: React.ReactNode;
    help?: React.ReactNode;
    prefix?: React.ReactNode;
    suffix?: React.ReactNode;
    className?: string;
    children: React.ReactNode;
}
export declare type InputProps = {
    name: string;
    value: value;
    required?: boolean;
    type?: string;
    validation?: validation;
    setValue: setValue;
    [key: string]: any;
};
export interface ControlLogicHook {
    formControlProps: FormControlProps;
    inputProps: InputProps;
}
